> ## Documentation Index
> Fetch the complete documentation index at: https://docs.costgraph.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Allow or block runners

> Allows (enabled true) or blocks (enabled false) several runner labels at one scope in one change. The provider, operating system, architecture and vCPUs are read from each label; if any label is not recognised, nothing is saved and the error names it. A block at any scope wins over an allow.



## OpenAPI

````yaml /api-reference/costgraph/openapi.json put /api/v1/tenant/ci/autopilot/labels
openapi: 3.0.0
info:
  description: Read and manage your CostGraph organization, spend, alerts, and settings.
  title: CostGraph API
  contact: {}
  version: '1.0'
servers:
  - url: https://api.costgraph.ai
security: []
tags:
  - name: ai
    x-group: AI
  - name: ai-serving
    x-group: AI serving
  - name: anomalies
    x-group: Anomalies
  - name: auth
    x-group: Auth
  - name: billing
    x-group: Billing
  - name: billing-export
    x-group: Billing export
  - name: budgets
    x-group: Budgets
  - name: ci
    x-group: CI
  - name: compute-recommendations
    x-group: Compute recommendations
  - name: config
    x-group: Config
  - name: context-graph
    x-group: Context graph
  - name: cost
    x-group: Cost
  - name: gpus
    x-group: GPUs
  - name: graphai
    x-group: Graph AI
  - name: integrations
    x-group: Integrations
  - name: invitations
    x-group: Invitations
  - name: kubernetes-clusters
    x-group: Kubernetes clusters
  - name: marketplace
    x-group: Marketplace
  - name: network
    x-group: Network
  - name: network-requests
    x-group: Network requests
  - name: notifications
    x-group: Notifications
  - name: oauth
    x-group: OAuth
  - name: oauth-clients
    x-group: OAuth clients
  - name: opencost
    x-group: OpenCost
  - name: organization
    x-group: Audit log
  - name: organizations
    x-group: Organizations
  - name: placement-alternatives
    x-group: Placement alternatives
  - name: reports
    x-group: Reports
  - name: settings
    x-group: Settings
  - name: sso
    x-group: Single sign-on
  - name: tenants
    x-group: Tenants
  - name: ticketing
    x-group: Ticketing
  - name: user
    x-group: Users
  - name: virtual-machines
    x-group: Virtual machines
  - name: virtual-tags
    x-group: Virtual tags
  - name: workflows
    x-group: Workflows
paths:
  /api/v1/tenant/ci/autopilot/labels:
    put:
      tags:
        - ci
      summary: Allow or block runners
      description: >-
        Allows (enabled true) or blocks (enabled false) several runner labels at
        one scope in one change. The provider, operating system, architecture
        and vCPUs are read from each label; if any label is not recognised,
        nothing is saved and the error names it. A block at any scope wins over
        an allow.
      parameters:
        - description: Tenant ID
          name: X-CostGraph-Tenant-ID
          in: header
          required: true
          schema:
            type: string
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/ci.PutLabelsRequest'
        description: Scope and labels
        required: true
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/responses.SuccessResponse'
                  - type: object
                    properties:
                      data:
                        type: array
                        items:
                          $ref: '#/components/schemas/db.CIAutopilotRunnerGroup'
        '400':
          description: Bad Request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/responses.ErrorResponse'
      security:
        - BearerAuth: []
components:
  schemas:
    ci.PutLabelsRequest:
      type: object
      required:
        - labels
      properties:
        labels:
          type: array
          minItems: 1
          items:
            $ref: '#/components/schemas/ci.PutLabelRequest'
        repository:
          type: string
          example: baselinehq/backend
        workflow_path:
          type: string
          example: .github/workflows/ci.yml
    responses.SuccessResponse:
      type: object
      required:
        - message
        - status
      properties:
        data: {}
        message:
          type: string
          example: some message
        status:
          type: string
          example: success
    db.CIAutopilotRunnerGroup:
      type: object
      required:
        - allowed
        - connected
        - provider
        - runners
      properties:
        allowed:
          type: boolean
        connected:
          type: boolean
        provider:
          type: string
        runners:
          type: array
          items:
            $ref: '#/components/schemas/db.CIAutopilotRunner'
    responses.ErrorResponse:
      type: object
      required:
        - message
        - status
      properties:
        message:
          type: string
          example: some message
        status:
          type: string
          example: error
    ci.PutLabelRequest:
      type: object
      required:
        - label
      properties:
        enabled:
          type: boolean
        label:
          type: string
          example: warp-ubuntu-latest-x64-4x
    db.CIAutopilotRunner:
      type: object
      required:
        - arch
        - cores
        - gpu
        - label
        - os
        - source
        - speed_measured
        - state
      properties:
        arch:
          type: string
        cores:
          type: integer
        currency:
          type: string
          nullable: true
        gpu:
          type: integer
        label:
          type: string
        os:
          type: string
        price_per_minute:
          type: number
          x-semantic: costAmount
          nullable: true
        ram_gb:
          type: number
          nullable: true
        setting:
          type: string
          enum:
            - allowed
            - blocked
          nullable: true
        setting_from:
          type: string
          enum:
            - org
            - repository
            - workflow
          nullable: true
        source:
          type: string
          enum:
            - connected
            - github_hosted
            - setting
        speed_measured:
          type: boolean
        speed_vs_github:
          type: number
          nullable: true
        state:
          type: string
          enum:
            - allowed
            - blocked
            - provider_off
            - outside_limits
  securitySchemes:
    BearerAuth:
      description: Enter "Bearer {token}"
      type: apiKey
      name: Authorization
      in: header

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.